package j2.lesson04.card;

/**
 * gvJ[h\NXB
 * @author arakawa
 * @version $Id: Card.java,v 1.3 2005/10/10 05:34:53 java2005 Exp $
 */
public class Card {
    
    /** Xy[h\萔 (=0). */
    public static final int SPADE = 0;
    /** _C\萔 (=1). */
    public static final int DIAMOND = 1;
    /** Nu\萔 (=2). */
    public static final int CLUB = 2;
    /** n[g\萔 (=3). */
    public static final int HEART = 3;
    
    /** }[N\萔當ւ̕ϊ\. */
    private static final String[] SUITE_STRING = {
        "Xy[h", "_C", "Nu", "n[g",
    };
    
    /** N當ւ̕ϊ\. */
    private static final String[] RANK_STRING = {
        "DUMMY",
        "A", "2", "3", "4", "5", "6", "7", "8", "9", "10",
        "J", "Q", "K",
    };
    
    /** gṽ}[N. */
    private final int suite;
    
    /** gṽN. */
    private final int rank;
    
    /**
     * J[h𐶐B
     * @param suite ̃J[h̃}[N
     * @param rank N
     */
    public Card(int suite, int rank) {
        super();
        if (suite != SPADE && suite != DIAMOND && suite != CLUB && suite != HEART) {
            throw new IllegalArgumentException("suite (" + suite + ")"); //$NON-NLS-1$$NON-NLS-2$
        }
        if (rank < 1 || rank > 13) {
            throw new IllegalArgumentException("rank (" + rank + ")"); //$NON-NLS-1$$NON-NLS-2$
        }
        this.suite = suite;
        this.rank = rank;
    }
    
    /**
     * ̃J[h̃N\擾B
     * @return ̃J[h̃N\
     */
    public String getRank() {
        return RANK_STRING[this.rank];
    }
    
    /**
     * ̃J[h̃N 1  13 ̒lƂĎ擾B
     * @return ̃J[h̃N
     */
    public int getRankAsInt() {
        return this.rank;
    }
    
    /**
     * ̃J[h̃}[N\擾B
     * @return ̃J[h̃}[N\
     */
    public String getSuite() {
        return SUITE_STRING[this.suite];
    }
    
    /**
     * ̃J[h̃}[N 0  3 ̒lƂĎ擾B
     * ̃NXŐ錾Ă萔ƏƂ炵킹邱ƂɂA}[N𔻒łB
     * @return ̃J[h̃}[N\l
     * @see #SPADE
     * @see #DIAMOND
     * @see #CLUB
     * @see #HEART
     */
    public int getSuiteAsInt() {
        return this.suite;
    }
    
    /**
     * ̃J[hn[gł邩ǂׂB
     * @return n[gȂ <code>true</code>
     */
    public boolean isHeart() {
        return this.suite == HEART;
    }
    
    /**
     * ̃J[hXy[hł邩ǂׂB
     * @return Xy[hȂ <code>true</code>
     */
    public boolean isSpade() {
        return this.suite == SPADE;
    }
    
    /**
     * ̃J[hNuł邩ǂׂB
     * @return NuȂ <code>true</code>
     */
    public boolean isClub() {
        return this.suite == CLUB;
    }
    
    /**
     * ̃J[h_Chł邩ǂׂB
     * @return _ChȂ <code>true</code>
     */
    public boolean isDiamond() {
        return this.suite == DIAMOND;
    }
    
    /**
     * ̃J[h̕\擾B
     * @return ̃J[h̕\
     */
    public String toString() {
        return this.getSuite() + "" + this.getRank(); //$NON-NLS-1$
    }
}
