package j2.lesson04.card;

import java.util.Collections;
import java.util.LinkedList;
import java.util.NoSuchElementException;
import java.util.Random;

/**
 * gvꎮ\NXB
 * @author arakawa
 * @version $Id: CardDeck.java,v 1.3 2005/10/10 05:48:28 java2005 Exp $
 */
public class CardDeck {
    
    private final LinkedList deck;
    
    /**
     * gvꎮ쐬B
     * Ԃł́AXy[hA,2..K,_CA,2,..,K,NuA,2,..,K,n[gA,2,..,K̏ɕłB
     */
    public CardDeck() {
        super();
        this.deck = new LinkedList();
        for (int i = 1; i <= 13; i++) {
            this.deck.add(new Card(Card.SPADE, i));
        }
        for (int i = 1; i <= 13; i++) {
            this.deck.add(new Card(Card.DIAMOND, i));
        }
        for (int i = 1; i <= 13; i++) {
            this.deck.add(new Card(Card.CLUB, i));
        }
        for (int i = 1; i <= 13; i++) {
            this.deck.add(new Card(Card.HEART, i));
        }
    }
    
    /**
     * ̃fbLVbtB
     */
    public void shuffle() {
        shuffle(System.currentTimeMillis());
    }
    
    /**
     * ̃fbLɃJ[hcĂ邩ǂׂB
     * @return J[hcĂ <code>true</code>
     */
    public boolean isEmpty() {
        return this.deck.isEmpty();
    }
    
    /**
     * ̃fbLɎcĂJ[h̖擾B
     * @return cĂJ[h̖
     */
    public int rest() {
        return this.deck.size();
    }
    
    /**
     * fbL̐擪J[hꖇ擾B
     * 擾J[h́AfbL폜B
     * @return fbL̐擪ɂJ[h
     */
    public Card takeFirst() {
        if (isEmpty()) {
            throw new NoSuchElementException();
        }
        return (Card) this.deck.removeFirst();
    }
    
    /**
     * fbL̖J[hꖇ擾B
     * 擾J[h́AfbL폜B
     * @return fbL̖ɂJ[h
     */
    public Card takeLast() {
        if (isEmpty()) {
            throw new NoSuchElementException();
        }
        return (Card) this.deck.removeLast();
    }
    
    /**
     * w肵J[hAfbL̐擪ɒǉB
     * @param c fbLɒǉJ[h
     */
    public void putFirst(Card c) {
        this.deck.addFirst(c);
    }
    
    /**
     * w肵J[hAfbL̖ɒǉB
     * @param c fbLɒǉJ[h
     */
    public void putLast(Card c) {
        this.deck.addLast(c);
    }
    
    /**
     * J[hw肵̎păVbtB
     * fbLɑ΂ē̎ł̃\bhĂяoꍇAʂ͓ɂȂB
     * @param seed ̎
     */
    public void shuffle(long seed) {
        Collections.shuffle(this.deck, new Random(seed));
    }
}
